#line 1 "//PC-HP/hubiC/_Electronique_/# LibStock #/mikroC RS232-Bootloader on PIC18F/Bootloader_PIC18F/Boot_Loader.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "//pc-hp/hubic/_electronique_/# libstock #/mikroc rs232-bootloader on pic18f/bootloader_pic18f/rom.h"
#pragma orgall 97632
#line 131 "//pc-hp/hubic/_electronique_/# libstock #/mikroc rs232-bootloader on pic18f/bootloader_pic18f/rom.h"
void Start_Bootload();
void Start_Program();

unsigned short UART_Write_Loop(char send, char receive);
#line 147 "//pc-hp/hubic/_electronique_/# libstock #/mikroc rs232-bootloader on pic18f/bootloader_pic18f/rom.h"
static char block[64];






void Start_Program() org  98304  - 64  {
}

unsigned short UART_Write_Loop(char send, char receive)
{
 unsigned short rslt = 0;

 while(1)
 {
 Delay_5ms();
 UART1_Write(send);
 Delay_5ms();

 rslt++;

 if(rslt == 255u) return 0;
 if(UART1_Read() == receive) return 1;
 }
}






void Write_Begin()
{
 FLASH_Erase_Write_64( 98304  - 64 , block);

  block[0] = 0xBC; 
  block[1] = 0xEF; 
  block[2] = 0xBE; 
  block[3] = 0xF0; 
}


void Start_Bootload() org  97996  {
 unsigned short i = 0, xx, yy;
 long j = 0;

 while(1)
 {
 if(i == 64u)
 {

 if(!j) Write_Begin();


 FLASH_Erase_Write_64(j, block);
 i = 0;
 j += 0x40;
 }

 UART1_Write('y');
 while(!UART1_Data_Ready()) ;

 yy = UART1_Read();

 UART1_Write('x');
 while(!UART1_Data_Ready()) ;

 xx = UART1_Read();

 block[i++] = yy;
 block[i++] = xx;
 }
}
#line 47 "//PC-HP/hubiC/_Electronique_/# LibStock #/mikroC RS232-Bootloader on PIC18F/Bootloader_PIC18F/Boot_Loader.c"
void main() org  97656  {

 UART1_Init(9600);

 if(UART_Write_Loop('g','r')) {
 Start_Bootload();
 }
 else
 {
 Start_Program();
 }
}
